#! /usr/bin/python
# -*- coding: utf-8 -*-
"""
Created on Wed Jun 24 15:28:31 2015

pySerial (in Paket python-serial ) muss installiert sein

Thermologger muss angeschlossen und an sein.

Einstellungen hier in der Datei ändern,
dann einfach von der Konsole aus starten.

@author: uha4
"""

OUTfile = "temps.txt"  # Datei in die die ausgabe der Temperaturen erfolgt
Trenner = "\t"         # Spaltentrenner in der Ausgabedatei
HEAD = ["Zeit", "T1", "T2", "T3", "T4"]
append = False         # sollen die Daten angehängt werden, falls die Datei schon existiert? 
NL = "\n"              # Zeichen für Zeilenwechsel

REPEAT = 12             # Anzahl der Lesevorgänge (0 für Endlosschleife)

PORT = '/dev/serial/by-id/usb-Prolific_Technology_Inc._USB-Serial_Controller_D-if00-port0'   #Gerätedatei

INTERVAL = 5   # Dateabrufinterval

import serial, time, os

# öffnen des seriellen Ports
Serial = serial.Serial(PORT, timeout=2)

# öffene der Ausgabedatei
if append and os.path.exists(OUTfile):
    dat = open(OUTfile, 'ab')
else:
    dat = open(OUTfile, 'wb')
    dat.write(Trenner.join(HEAD)+NL)
 
x = 0  
if not REPEAT:
    last = 1
else:
    last = REPEAT
while x < last:
    if REPEAT:
        x += 1
    Zeit = time.time()
    Serial.write('A')
    data = bytearray(Serial.read(45))
    if len(data) < 45:
        print "keine oder fehlerhafte Daten empfangen!"
        print "(Antwort hatte %i byte)" % len(data)
        break
    T1 = (data[7]*256 + data[8])*0.1
    T2 = (data[9]*256 + data[10])*0.1
    T3 = (data[11]*256 + data[12])*0.1
    T4 = (data[13]*256 + data[14])*0.1
    line = ["%0.1f"%Zeit, str(T1), str(T2), str(T3), str(T4)]
    dat.write(Trenner.join(line)+NL)
    dat.flush()
    time.sleep(INTERVAL - (time.time() - Zeit))

dat.close()